'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

var _TabStyles = require('../Tabs/TabStyles');

var _Tab = require('../Tabs/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _Workspace = require('../Workspace/Workspace');

var _Workspace2 = _interopRequireDefault(_Workspace);

var _Functions = require('../utils/Functions');

var _HelpReducer = require('../utils/HelpReducer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Menu = function (_Component) {
	_inherits(Menu, _Component);

	function Menu(props) {
		_classCallCheck(this, Menu);

		var _this = _possibleConstructorReturn(this, (Menu.__proto__ || Object.getPrototypeOf(Menu)).call(this, props));

		_this.componentWillMount = function () {
			if (window.location.pathname.includes(_this.props.route) && _this.props.MenuID !== undefined && _this.props.activeMenu !== _this.props.MenuID) {
				_this.props.setActiveMenu(_this.props.MenuID);
			}
			_this.setHelpID();
		};

		_this.setHelpID = function () {
			if (_this.props.helpID) {
				(0, _HelpReducer.SetHelpID)(_this.props.helpID);
			}
		};

		_this.route = function (child) {
			return _this.props.route !== undefined ? _this.props.route : (0, _Functions.convertLabelToRoute)(_this.props.label);
		};

		_this.childRoute = function (child) {
			return child.props.route !== undefined ? child.props.route : (0, _Functions.convertLabelToRoute)(child.props.label);
		};

		_this.renderChildren = function (children) {
			return children.map(function (child, index) {
				return _react2.default.createElement(_reactRouterDom.Route, { key: index, path: _this.route() + _this.childRoute(child),
					exact: (0, _Functions.isExact)(_this.childRoute(child)),
					component: _this.renderChild(child) });
			});
		};

		_this.renderChild = function (child) {
			return function () {
				return _react2.default.createElement(
					_Workspace2.default,
					null,
					child.props.children
				);
			};
		};

		_this.setActiveTab = function (key) {
			_this.setState({ activeTab: key });
			if (_react2.default.Children.toArray(_this.props.children)[key].props.helpID !== undefined) _this.setHelpID(_react2.default.Children.toArray(_this.props.children)[key].props.helpID);
		};

		_this.renderTabs = function (children) {
			if (children[0].type === _Tab2.default) return _react2.default.createElement(
				_TabStyles.SceneDiv,
				null,
				!_this.props.quicknav ? _react2.default.createElement(
					_TabStyles.TabList,
					null,
					children.map(function (child, index) {
						return _react2.default.createElement(_Tab2.default, { key: index,
							helpID: child.props.helpID ? child.props.helpID : undefined,
							tabID: index,
							exact: (0, _Functions.isExact)(_this.childRoute(child)),
							label: child.props.label,
							icon: child.props.icon,
							route: _this.route() + _this.childRoute(child),
							setActiveTab: _this.setActiveTab,
							activeTab: _this.state.activeTab });
					})
				) : null,
				_react2.default.createElement(
					_reactRouterDom.Switch,
					null,
					_this.renderChildren(children)
				)
			);else {
				return _react2.default.createElement(
					_TabStyles.SceneDiv,
					null,
					_this.renderNoTabs(children)
				);
			}
		};

		_this.renderNoTabs = function (children) {
			return _react2.default.createElement(
				_Workspace2.default,
				{ noTab: true, helpID: _this.props.helpID ? _this.props.helpID : null },
				children
			);
		};

		_this.state = {
			activeTab: -1
		};
		return _this;
	}

	//#region Label Converting for Menu


	//#endregion

	//#region RenderChildren

	//#endregion

	_createClass(Menu, [{
		key: 'render',
		value: function render() {
			return this.renderTabs(_react2.default.Children.toArray(this.props.children));
		}
	}]);

	return Menu;
}(_react.Component);

Menu.propTypes = {
	label: _propTypes2.default.string,
	route: _propTypes2.default.string,
	icon: _propTypes2.default.string
};

exports.default = Menu;