'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _MenuStyles = require('../MenuStyles');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _odeumUi = require('odeum-ui');

var _HelpReducer = require('../../utils/HelpReducer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MenuItem = function (_Component) {
	_inherits(MenuItem, _Component);

	function MenuItem() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, MenuItem);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MenuItem.__proto__ || Object.getPrototypeOf(MenuItem)).call.apply(_ref, [this].concat(args))), _this), _this.cutRoutes = function (string) {
			var match = string.match(/(\/\S*\/)|(\/\S*$)/i);
			return match ? match[0] : null;
		}, _this.setHelpID = function () {
			if (_this.props.helpID) {
				(0, _HelpReducer.SetHelpID)(_this.props.helpID);
			}
		}, _this.activate = function () {
			_this.props.onClick(_this.props.MenuID);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(MenuItem, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.setHelpID();
			if (this.cutRoutes(window.location.pathname) === this.cutRoutes(this.props.route)) {
				this.activate();
			}
		}
	}, {
		key: 'render',
		value: function render() {
			return _react2.default.createElement(
				_MenuStyles.Link,
				{ title: this.props.label, to: this.props.route, achordeon: this.props.achordeon, onClick: this.activate, activemenu: this.props.active.toString() },
				_react2.default.createElement(
					_MenuStyles.IconDiv,
					null,
					_react2.default.createElement(_odeumUi.Icon, { color: 'white', iconSize: 18, icon: this.props.icon ? this.props.icon : this.defaultProps.icon, style: { marginRight: '0px' } })
				),
				_react2.default.createElement(
					_MenuStyles.MenuText,
					null,
					this.props.label
				),
				_react2.default.createElement(
					_MenuStyles.ArrowIconDiv,
					null,
					_react2.default.createElement(_odeumUi.Icon, { icon: 'keyboard_arrow_right', iconSize: 25, color: 'white', style: { marginRight: '0px' } })
				)
			);
		}
	}]);

	return MenuItem;
}(_react.Component);

MenuItem.propTypes = {
	label: _propTypes2.default.string.isRequired,
	route: _propTypes2.default.string.isRequired,
	icon: _propTypes2.default.string

};
MenuItem.defaultProps = {
	icon: 'menu'
};
exports.default = MenuItem;