'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _QuickNavigationStyles = require('./QuickNavigationStyles');

var _Tab = require('../Tabs/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _Functions = require('../utils/Functions');

var _odeumUi = require('odeum-ui');

var _HeaderButton = require('./HeaderButton');

var _HeaderButton2 = _interopRequireDefault(_HeaderButton);

var _HelpPopUp = require('../Help/HelpPopUp');

var _HelpPopUp2 = _interopRequireDefault(_HelpPopUp);

var _HelpReducer = require('../utils/HelpReducer');

var _Protected = require('../Login/Protected');

var _Protected2 = _interopRequireDefault(_Protected);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var QuickNavigation = function (_Component) {
	_inherits(QuickNavigation, _Component);

	function QuickNavigation(props) {
		_classCallCheck(this, QuickNavigation);

		var _this = _possibleConstructorReturn(this, (QuickNavigation.__proto__ || Object.getPrototypeOf(QuickNavigation)).call(this, props));

		_this.helpClick = function () {
			_this.setState({ showHelp: !_this.state.showHelp });
		};

		_this.tabClick = function (id, helpID) {
			return function (e) {
				// e.preventDefault()
				(0, _HelpReducer.SetHelpID)(helpID);
				var activeTab = { tab: parseInt(e.target.id, 10), menu: _this.state.activeMenu };
				_this.setState({ quickNav: false, activeTab: activeTab });
			};
		};

		_this.menuClick = function () {
			return function (e) {
				e.stopPropagation();
			};
		};

		_this.setActiveMenu = function (index, closeNav) {
			return function (e) {
				e.preventDefault();
				e.stopPropagation();
				_this.setState({ activeMenu: index, quickNav: !closeNav });
			};
		};

		_this.openNav = function (e) {
			e.stopPropagation();
			_this.setState({ quickNav: !_this.state.quickNav });
			if (_this.state.showHelp === true) _this.setState({ showHelp: false });
		};

		_this.activeTab = function (tab, menu) {
			return tab === _this.state.activeTab.tab && menu === _this.state.activeTab.menu ? 'true' : 'false';
		};

		_this.renderProtectedMenu = function (menu, index) {
			if (menu.type === _Protected2.default) {
				if (_this.props.loggedIn === true) {
					var childs = _react2.default.Children.toArray(menu.props.children);
					return childs.map(function (m, i) {
						return _this.renderMenuItem(m, { index: index, protected: i });
					});
				}
			} else return _this.renderMenuItem(menu, index);
		};

		_this.renderMenuItem = function (menu, index) {
			var icon = menu.props.icon ? menu.props.icon : 'menu';
			var route = menu.props.route !== undefined ? menu.props.route : (0, _Functions.convertLabelToRoute)(menu.props.label);
			// console.log(route)
			if (route === '' || route === '/') {
				return _react2.default.createElement(
					_QuickNavigationStyles.MenuItem,
					{ key: index.protected ? index.index + index.protected : index, onClick: _this.setActiveMenu(index, true) },
					_react2.default.createElement(
						_QuickNavigationStyles.Link,
						{ to: route },
						_react2.default.createElement(_odeumUi.Icon, { icon: 'home', iconSize: 28, style: { marginBottom: '4px', color: 'inherit' } }),
						'Home'
					)
				);
			} else {
				if (_react2.default.Children.toArray(menu.props.children)[0].type === _Tab2.default) return _react2.default.createElement(
					_QuickNavigationStyles.MenuItem,
					{ key: index.protected ? index.index + index.protected : index, onClick: _this.setActiveMenu(index, false) },
					_react2.default.createElement(_odeumUi.Icon, { icon: icon, iconSize: 28, style: { marginBottom: '4px', color: 'inherit' } }),
					menu.props.label
				);else return _react2.default.createElement(
					_QuickNavigationStyles.MenuItem,
					{ key: index.protected ? index.index + index.protected : index, onClick: _this.setActiveMenu(index, true) },
					_react2.default.createElement(
						_QuickNavigationStyles.Link,
						{ to: route },
						_react2.default.createElement(_odeumUi.Icon, { icon: icon, iconSize: 28, style: { marginBottom: '4px', color: 'inherit' } }),
						menu.props.label
					)
				);
			}
		};

		_this.renderTabItem = function (tab, menu, index) {
			var menuRoute = menu.props.route !== undefined ? menu.props.route : (0, _Functions.convertLabelToRoute)(menu.props.label);
			var route = tab.props.route !== undefined ? menuRoute + tab.props.route : menuRoute + (0, _Functions.convertLabelToRoute)(tab.props.label);
			// console.log(menu, menuRoute, menu.props.route)
			// console.log('----')
			// console.log(tab, tab.props.route, route)
			return _react2.default.createElement(
				_QuickNavigationStyles.TabItem,
				{ key: index.protected ? index.index + index.protected : index, helpid: tab.props.helpID, activetab: _this.activeTab(index, _this.state.activeMenu), id: index, to: route, onClick: _this.tabClick(index, tab.props.helpID) },
				tab.props.label ? tab.props.label : tab.props.route
			);
		};

		_this.state = {
			quickNav: false,
			showButton: true,
			showHelp: false,
			activeMenu: 0,
			activeTab: {
				tab: 0,
				menu: 0
			}
		};
		return _this;
	}

	_createClass(QuickNavigation, [{
		key: 'renderProtectedTabs',
		value: function renderProtectedTabs() {
			// return React.Children.toArray(this.state.activeMenu.props.children).map((tab, index) => {
			// 	console.log('tab', tab)
			// 	return this.renderTabItem(tab, this.state.activeMenu, index)}
			// )
		}
	}, {
		key: 'renderTabs',
		value: function renderTabs() {
			var _this2 = this;

			if (this.state.activeMenu.protected !== undefined) {
				// console.log('bing')
				// console.log(this.state.activeMenu)
				var ProtectedMenu = this.props.menus[this.state.activeMenu.index].props.children;
				// console.log(ProtectedMenus)
				//  console.log(React.Children.toArray(ProtectedMenus.props.children[this.state.activeMenu.protected]))
				return _react2.default.Children.toArray(ProtectedMenu[this.state.activeMenu.protected].props.children).map(function (tab, index) {
					return _this2.renderTabItem(tab, ProtectedMenu[_this2.state.activeMenu.protected], { index: _this2.state.activeMenu.index, protected: index });
				});
			} else {
				return _react2.default.Children.toArray(this.props.menus[this.state.activeMenu].props.children).map(function (tab, index) {
					return tab.type === _Tab2.default ? _this2.renderTabItem(tab, _this2.props.menus[_this2.state.activeMenu], index) : undefined;
				});
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			// console.log(this.props)
			var _state = this.state,
			    quickNav = _state.quickNav,
			    showHelp = _state.showHelp;

			return _react2.default.createElement(
				_QuickNavigationStyles.QuickNav,
				null,
				_react2.default.createElement(_HelpPopUp2.default, { openHelp: showHelp, handleHelp: this.helpClick }),
				_react2.default.createElement(
					_QuickNavigationStyles.QuickNavButton,
					{ onClick: this.openNav },
					_react2.default.createElement(_odeumUi.Icon, { icon: 'menu', color: 'white', iconSize: 18, style: { marginRight: '8px' } }),
					'Quick Menu'
				),
				_react2.default.createElement(
					_QuickNavigationStyles.QuickNavContainer,
					{ quickNav: quickNav, onClick: this.openNav },
					_react2.default.createElement(
						_QuickNavigationStyles.QuickNavMenu,
						{ onClick: this.menuClick() },
						_react2.default.createElement(
							_QuickNavigationStyles.Header,
							null,
							_react2.default.createElement(
								_QuickNavigationStyles.SubHeader,
								null,
								_react2.default.createElement(_HeaderButton2.default, { icon: 'help', onClick: this.helpClick }),
								_react2.default.createElement(_HeaderButton2.default, { icon: 'search' })
							),
							_react2.default.createElement(
								'div',
								{ style: { alignSelf: 'center', justifyContent: 'center' } },
								'Quick Navigation'
							),
							_react2.default.createElement(_HeaderButton2.default, { icon: 'close', onClick: this.openNav })
						),
						_react2.default.createElement(_QuickNavigationStyles.Spacer, null),
						_react2.default.createElement(
							_QuickNavigationStyles.TabList,
							null,
							this.renderTabs()
						),
						_react2.default.createElement(_QuickNavigationStyles.Spacer, null),
						_react2.default.createElement(
							_QuickNavigationStyles.MenuList,
							null,
							_react2.default.Children.toArray(this.props.menus).map(function (menu, index) {
								return _this3.renderProtectedMenu(menu, index);
							})
						)
					)
				)
			);
		}
	}]);

	return QuickNavigation;
}(_react.Component);

exports.default = QuickNavigation;